/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.base.objects.factory.tracker;

import java.util.HashMap;
import java.util.Map;

import org.osgi.framework.Bundle;
import org.osgi.framework.ServiceRegistration;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.google.gson.JsonObject;

import ru.entaxy.platform.base.objects.factory.EntaxyFactory;
import ru.entaxy.platform.base.support.CommonUtils;

public class TrackedFactory {

	private static final Logger log = LoggerFactory.getLogger(TrackedFactory.class);
	
	public static Map<String, TrackedFactory> trackedFactoriesMap = new HashMap<>();
	
	private String id;
	private Bundle bundle; 
	private String configString;
	
	private ServiceRegistration<EntaxyFactory> serviceRegistration;
	
	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public Bundle getBundle() {
		return bundle;
	}

	public void setBundle(Bundle bundle) {
		this.bundle = bundle;
	}

	public String getConfigString() {
		return configString;
	}

	public void setConfigString(String configString) {
		this.configString = configString;
	}

	public ServiceRegistration<EntaxyFactory> getServiceRegistration() {
		return serviceRegistration;
	}

	public void setServiceRegistration(ServiceRegistration<EntaxyFactory> serviceRegistration) {
		this.serviceRegistration = serviceRegistration;
	}
	
	public void unregister() {
		if (this.serviceRegistration != null)
			try {
				this.serviceRegistration.unregister();
			} catch (IllegalStateException e) { 
				// skip exception typical for bundle refreshing process
				if (CommonUtils.isValid(e.getMessage()) && e.getMessage().contains("Service already unregistered"))
					return;
				log.warn("TrackedFactory [" + getId() + "]", e);
			} catch (Exception e) {
				log.warn("TrackedFactory [" + getId() + "]", e);
			}
	}
}
